/*
Rigid registration of different poses of animated shapes
Marco Livesu and Riccardo Scateni - University of Cagliari
proceedings of WSCG 2013, Plzen, Czech Republic
*/

#ifndef MESH_H
#define MESH_H

#include <vector>

#include <vcg/simplex/vertex/base.h>
#include <vcg/simplex/vertex/component.h>
#include <vcg/simplex/face/base.h>
#include <vcg/simplex/face/component.h>
#include <vcg/simplex/face/component_ocf.h>

#include <vcg/complex/trimesh/base.h>

class CGFace;
class CGVertex;

class CGTypes : public vcg::UsedTypes< vcg::Use<CGVertex>::AsVertexType, vcg::Use<CGFace>::AsFaceType>{};

class CGVertex: public vcg::Vertex<CGTypes,
                       vcg::vertex::Coord3d,
                       vcg::vertex::Normal3d,
                       vcg::vertex::Color4b,
                       vcg::vertex::Qualityf,
                       vcg::vertex::Mark,
                       vcg::vertex::VFAdj>
{};

class CGFace: public vcg::Face<CGTypes,
                     vcg::face::FFAdj,
                     vcg::face::VFAdj,
                     vcg::face::Normal3d,
                     vcg::face::VertexRef,
                     vcg::face::BitFlags,
                     vcg::face::Mark,
                     vcg::vertex::Color4b,
                     vcg::vertex::Qualityf>
{};

class CGMesh : public vcg::tri::TriMesh< std::vector<CGVertex>, std::vector<CGFace> > {};

typedef CGMesh::CoordType CGPoint;


#endif // MESH_H
